let SCALAR_SYMMETRIC = prove
  (`!a s1 s inprod. s1 SUBSET s /\ is_cfun_subspace s1 /\ real a ==>  is_symmetric (s,inprod) s1 (a%I)`,
  SYMMETRIC_TAC);;
  
add_symmetric_thm SCALAR_SYMMETRIC;;


let ADD_SCALAR_SYMMETRIC = prove
(`!a s1 op s inprod. is_symmetric (s,inprod) s1 op /\ real a ==>  
      is_symmetric (s,inprod) s1 (op+a%I)`,
  SIMP_TAC[IS_SYMMETRIC;is_unbounded_linear_cop;I_THM;COP_ADD_THM;COP_SMUL_THM;CFUN_ADD_LDISTRIB]
  THEN REPEAT STRIP_TAC THENL[CFUN_ARITH_TAC;ASM_MESON_TAC[CFUN_SMUL_ASSOC;COMPLEX_MUL_SYM];
  CFUN_ARITH_TAC;ASM_MESON_TAC[CFUN_SMUL_ASSOC;COMPLEX_MUL_SYM];
  IMP_REWRITE_TAC[CFUN_SUBSPACE_ADD;CFUN_SUBSPACE_SMUL;INNER_SPACE_IS_SUBSPACE] THEN
  ASSUM_LIST SET_TAC;IMP_REWRITE_TAC[CFUN_SUBSPACE_ADD;CFUN_SUBSPACE_SMUL;INNER_SPACE_IS_SUBSPACE] THEN
  ASSUM_LIST SET_TAC;
  IMP_REWRITE_TAC[INPROD_ADD_LDIST;INPROD_ADD_RDIST;INPROD_RSMUL;INPROD_LSMUL;
  REAL_IMP_CNJ;CFUN_SUBSPACE_SMUL;INNER_SPACE_IS_SUBSPACE] THEN
  REPEAT CONJ_TAC THEN TRY  (ASSUM_LIST SET_TAC) THEN ASM_SIMP_TAC[]]);;
  
add_symmetric_thm ADD_SCALAR_SYMMETRIC;;
  

let SYMMETRIC_MUL = prove
(`!op1 op2 s1 s inprod. is_hermitian_unbounded (s,inprod) s1 s1 op1 op2
  ==> is_symmetric (s,inprod) {x| x IN s1 /\ op2 x IN s1} (op1**op2)`,
  REWRITE_TAC[is_symmetric] THEN 
  IMP_REWRITE_TAC[ MUL_HERM_UNBOUNDED] THEN SIMP_TAC[HERM_SYM_UNBOUNDED]);;
  
add_symmetric_thm  SYMMETRIC_MUL;;

let tem x =  MATCH_MP (REWRITE_RULE [GSYM IMP_IMP] x) SQ_INTEGRABLE_INNER_SPACE;;

let EQUV_SMUL = prove
  (`!a x y.
          ~(a = Cx (&0)) /\ x IN sq_integrable /\ y IN sq_integrable
          ==> ((a % x equv a % y) r_inprod <=> (x equv y) r_inprod)`,
   REPEAT STRIP_TAC THEN EQ_TAC THEN
   IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_LDIST;tem INPROD_SUB_RDIST;tem INPROD_LSMUL;tem INPROD_RSMUL;tem INNER_SPACE_SMUL;
   tem INNER_SPACE_SUB;SQ_INTEGRABLE_INNER_SPACE;GSYM COMPLEX_SUB_LDISTRIB;COMPLEX_ENTIRE]
   THEN  ASM_MESON_TAC[MESON [CNJ_CX;GSYM CNJ_CNJ] `cnj a = Cx(&0) <=> a = Cx(&0)`]);;

let EQUV_SMUL_ALT = prove
  (`!a x y.
           x IN sq_integrable /\ y IN sq_integrable
          ==>  (x equv y) r_inprod ==> ((a % x equv a % y) r_inprod )`,
   IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_LDIST;tem INPROD_SUB_RDIST;tem INPROD_LSMUL;tem INPROD_RSMUL;tem INNER_SPACE_SMUL;
   tem INNER_SPACE_SUB;SQ_INTEGRABLE_INNER_SPACE;GSYM COMPLEX_SUB_LDISTRIB;COMPLEX_ENTIRE]
   THEN  ASM_MESON_TAC[MESON [CNJ_CX;GSYM CNJ_CNJ] `cnj a = Cx(&0) <=> a = Cx(&0)`]);;
   
   
let CFUN_EQUV_LADD = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==>  ((z equv (x+y))r_inprod <=> ( x equv (z-y))r_inprod)`,
  IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_RDIST;tem INPROD_SUB_LDIST;tem INPROD_ADD_LDIST;
  tem INPROD_ADD_RDIST;tem INNER_SPACE_SUB;tem INNER_SPACE_ADD] THEN
  CONV_TAC COMPLEX_FIELD);;
  
let CFUN_EQUV_LADD_ALT = ONCE_REWRITE_RULE[CFUN_ADD_SYM] CFUN_EQUV_LADD;;

let CFUN_EQUV_LSUB = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (((x - y) equv z)r_inprod <=> (x equv (z+y))r_inprod)`,
  IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_RDIST;tem INPROD_SUB_LDIST;tem INPROD_ADD_LDIST;
  tem INPROD_ADD_RDIST;tem INNER_SPACE_SUB;tem INNER_SPACE_ADD] THEN
  CONV_TAC COMPLEX_FIELD);;
  
let CFUN_EQUV_RSUB = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (( x equv (z-y))r_inprod <=> ((x+y) equv z)r_inprod)`,
  IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_RDIST;tem INPROD_SUB_LDIST;tem INPROD_ADD_LDIST;
  tem INPROD_ADD_RDIST;tem INNER_SPACE_SUB;tem INNER_SPACE_ADD] THEN
  CONV_TAC COMPLEX_FIELD);;

let CFUN_EQUV_RSUB_ALT = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (( (z-y) equv x)r_inprod <=> (z equv (x+y))r_inprod)`,
  IMP_REWRITE_TAC[are_equv;tem INPROD_SUB_RDIST;tem INPROD_SUB_LDIST;tem INPROD_ADD_LDIST;
  tem INPROD_ADD_RDIST;tem INNER_SPACE_SUB;tem INNER_SPACE_ADD] THEN
  CONV_TAC COMPLEX_FIELD);;

  let CFUN_EQUV_ZERO_ADD = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (((y+x) equv x)r_inprod <=> (y equv cfun_zero)r_inprod)`,
  SIMP_TAC[GSYM CFUN_EQUV_RSUB;CFUN_SUB_REFL]);;
  
 
let CFUN_EQ_ADD_LCANCEL = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (((x+y) equv (x+z))r_inprod <=> (y equv z)r_inprod)`,
  SIMP_TAC[GSYM (ONCE_REWRITE_RULE[CFUN_ADD_SYM]CFUN_EQUV_RSUB);tem INNER_SPACE_ADD;CFUN_ARITH`((x:cfun)+z)-x =z`]);;

  
let CFUN_EQ_ADD_RCANCEL = prove
(`!x y z. x IN sq_integrable /\ y IN sq_integrable /\ z IN sq_integrable
  ==> (((x+z) equv (y+z))r_inprod <=> (x equv y)r_inprod)`,
  SIMP_TAC[GSYM (CFUN_EQUV_RSUB);tem INNER_SPACE_ADD;CFUN_ARITH`((x:cfun)+z)-z =x`]);;

let CFUN_EQ_SUB_LCANCEL = CFUN_ARITH `!x y z:cfun. x - y = x - z <=> y = z`;;

let CFUN_EQ_SUB_RADD = CFUN_ARITH `!x y z:cfun. x - y = z <=> x = z + y`;;

let CFUN_SUBST_LADD = prove
(`!x1 x2 y z. x1 IN sq_integrable /\ x2 IN sq_integrable/\ 
  y IN sq_integrable /\ z IN sq_integrable /\ (x1 equv x2) r_inprod
  ==> (((x1+y) equv z)r_inprod <=> ((x2+y) equv z)r_inprod)`,
  SIMP_TAC[GSYM CFUN_EQUV_RSUB] THEN
  MESON_TAC[tem INPROD_EQUV_TRANSTIVE;tem INPROD_EQUV_SYM;tem INNER_SPACE_SUB]);;

  let CFUN_SUBST_LADD_ALT2 = prove
(`!x1 x2 y z. (x1 equv x2) r_inprod ==> x1 IN sq_integrable /\ x2 IN sq_integrable/\ 
  y IN sq_integrable /\ z IN sq_integrable  
  ==> (((x1+y) equv z)r_inprod <=> ((x2+y) equv z)r_inprod)`,
  MESON_TAC[CFUN_SUBST_LADD]);;
  
let CFUN_SUBST_RADD = ONCE_REWRITE_RULE[CFUN_ADD_SYM] CFUN_SUBST_LADD;;

let CFUN_SUBST_LADD_ALT = prove
(`!x1 x2 y z. (x1 equv x2) r_inprod ==> x1 IN sq_integrable /\ x2 IN sq_integrable/\ 
  y IN sq_integrable /\ z IN sq_integrable  
  ==> ((z equv (x1+y) )r_inprod <=> (z equv (x2+y))r_inprod)`,
  SIMP_TAC[GSYM CFUN_EQUV_LSUB] THEN
  MESON_TAC[tem INPROD_EQUV_TRANSTIVE;tem INPROD_EQUV_SYM;tem INNER_SPACE_SUB]);;
let CFUN_SUBST_RADD_ALT = ONCE_REWRITE_RULE[CFUN_ADD_SYM] CFUN_SUBST_LADD_ALT;;

let CFUN_SUBST_LSUB = prove
(`!x1 x2 y z. x1 IN sq_integrable /\ x2 IN sq_integrable/\ 
  y IN sq_integrable /\ z IN sq_integrable /\ (x1 equv x2) r_inprod
  ==> (((x1-y) equv z)r_inprod <=> ((x2-y) equv z)r_inprod)`,
  SIMP_TAC[ CFUN_EQUV_RSUB_ALT] THEN
  MESON_TAC[tem INPROD_EQUV_TRANSTIVE;tem INPROD_EQUV_SYM;tem INNER_SPACE_ADD]);;

let CFUN_SUBST_RSUB = prove
(`!x1 x2 y z. x1 IN sq_integrable /\ x2 IN sq_integrable/\ 
  y IN sq_integrable /\ z IN sq_integrable /\ (x1 equv x2) r_inprod
  ==> (((y-x1) equv z)r_inprod <=> ((y-x2) equv z)r_inprod)`,
  SIMP_TAC[ CFUN_EQUV_LSUB;ONCE_REWRITE_RULE[CFUN_ADD_SYM]CFUN_EQUV_LADD] THEN
  MESON_TAC[tem INPROD_EQUV_TRANSTIVE;tem INPROD_EQUV_SYM;tem INNER_SPACE_SUB]);;
  

let INPROD_EQUV_SYM_ALT = inner_space_prove
	(`!x y. x IN s /\ y IN s   ==> ((x equv y) inprod ==> (y equv x) inprod):`,
	REPEAT STRIP_TAC THEN
	ASM_MESON_TAC[INPROD_EQUV_SYM]);;
	   
let INPROD_EQUV_SYM_ALT2 = inner_space_prove
	(`!x y. ((x equv y) inprod ==> x IN s /\ y IN s   ==> (y equv x) inprod):`,
	ASM_MESON_TAC[INPROD_EQUV_SYM_ALT]);;

	
let INPROD_EQUV_LREPLACE_ALT = 	prove
	(`!s inprod x y z.
         is_inner_space (s,inprod)==>
		  (x equv y) inprod  ==>
         x IN s /\
         y IN s /\
         z IN s
         ==> inprod x z = inprod y z`,
       MESON_TAC[INPROD_EQUV_LREPLACE]);;

let is_local_bounded = new_definition
`!s h inprod f.
         is_local_bounded1 (s,inprod) h s1 <=>
         is_inner_space (s,inprod)
         ==> (?B. &0 < B /\
                  (!x. x IN s1 
                       ==> sqrt (real_of_complex (inprod (h x) (h x))) <=
                           B * sqrt (real_of_complex (inprod x x))))`;;
						   
			
let CFUN_LIM_ULINEAR = prove
 (`!net:(A)net h s1 f l s inprod.
        cfun_lim1 (s,inprod) f l net /\ is_unbounded_linear_cop s1 h
		/\ (!x. x IN s1 ==> x IN s /\ h x IN s)
		/\ (!x. f x IN s1) /\ l IN s1 /\
                  is_local_bounded1 (s,inprod) h {x| ?n. x  = f n -l}
                ==> cfun_lim1 (s,inprod) (\x.h (f x)) (h l) net`,
  REWRITE_TAC[FORALL_INNER_SPACE_THM] THEN
  REPEAT GEN_TAC THEN REWRITE_TAC[CFUN_LIM] THEN
  ASM_CASES_TAC `trivial_limit (net:(A)net)` THEN
  ASM_SIMP_TAC[is_local_bounded] THEN
  STRIP_TAC THEN  FIRST_ASSUM(fun thm -> FIRST_ASSUM (ASSUME_TAC o MP thm)) THEN
  FIRST_ASSUM STRIP_ASSUME_TAC  THEN REPEAT STRIP_TAC THEN
  FIRST_X_ASSUM(MP_TAC o Pa.SPEC `e / B:`) THEN
  ASM_SIMP_TAC[REAL_LT_DIV;REAL_LT_RDIV_EQ;cfun_dist] THEN 
  IMP_REWRITE_TAC[GSYM (Pa.SPEC "s1" ULINCOP_SUB);ULINCOP_SUBSPACE] THEN
  REPEAT STRIP_TAC THEN Pa.EXISTS_TAC "y" THEN CONJ_TAC THENL[ASM_MESON_TAC[];ALL_TAC]
  THEN REPEAT STRIP_TAC THEN MATCH_MP_TAC REAL_LET_TRANS THEN 
  Pa.EXISTS_TAC "sqrt (real_of_complex (inprod (f x' - l) (f x' - l))) * B" THEN ASM_SIMP_TAC[]
  THEN ONCE_REWRITE_TAC[REAL_MUL_SYM] THEN 
  IMP_REWRITE_TAC[IN_ELIM_THM] THEN Pa.EXISTS_TAC "x'" THEN REWRITE_TAC[]);;

  		  
let SCALAR_BOUNDED = prove
 (`!a s inprod  s1. (!x. x IN s1 ==> x IN s) ==>
    is_local_bounded1 (s, inprod) (\x:cfun. a % x) s1`,
        SIMP_TAC[is_local_bounded]
        THEN REPEAT STRIP_TAC
        THEN Pa.ASM_CASES_TAC `a = Cx(&0):`
         THENL[  Pa.EXISTS_TAC `&1:` THEN
             ASM_REWRITE_TAC[REAL_LT_01;CFUN_SMUL_LZERO;REAL_MUL_LID] THEN
                 ASM_MESON_TAC[SQRT_POS_LE;REAL_OF_COMPLEX_CX;SQRT_0;INPROD_ZERO;
                 INPROD_SELF_POS];Pa.EXISTS_TAC `norm a:` THEN
                 IMP_REWRITE_TAC[COMPLEX_NORM_NZ;REAL_LE_REFL;GSYM cfun_norm;
                 CFUN_NORM_SMUL]]);;


let CFUN_LIM_SMUL = prove
 (`!a net f l  innerspc.
    cfun_lim1 innerspc f l net
        ==> cfun_lim1 innerspc (\x. a% f(x)) (a%l) net`,
          REWRITE_TAC[FORALL_INNER_SPACE_THM] THEN
          REPEAT STRIP_TAC THEN MATCH_MP_TAC CFUN_LIM_ULINEAR THEN
          Pa.EXISTS_TAC "s" THEN IMP_REWRITE_TAC[REWRITE_RULE [ETA_AX]SCALAR_BOUNDED;IN_ELIM_THM] THEN
		  RULE_ASSUM_TAC(REWRITE_RULE[cfun_lim]) THEN
                  ASM_SIMP_TAC[CONJ_ASSOC;is_unbounded_linear_cop] THEN CONJ_TAC THENL[
                  ASM_MESON_TAC[INNER_SPACE_IS_SUBSPACE;CFUN_SUBSPACE_SMUL;CFUN_ADD_LDISTRIB;CFUN_SMUL_ASSOC;COMPLEX_MUL_SYM];
				  REWRITE_TAC[IN_ELIM_THM] THEN REPEAT STRIP_TAC THEN IMP_REWRITE_TAC[INNER_SPACE_SUB] 
				  THEN Pa.EXISTS_TAC "inprod" THEN ASM_REWRITE_TAC[]]);;

				  			   
let CFUN_SERIES_SLINEAR = prove
 (`!f h1 l s s1 s2 inprod. cfun_sums (s2,inprod) f l s /\
     is_unbounded_linear_cop s1 h1  /\ 
         (!x. x IN s1 ==> x IN s2 /\ h1 x IN s2) /\
         (!n. f n IN s1) /\ l IN s1
		 /\ is_local_bounded1 (s2,inprod) h1 {x| ?n. x = cfun_sum (s INTER(0..n)) f - l} 
       ==> cfun_sums (s2,inprod) (\n. h1(f n)) (h1 l) s `,
           REWRITE_TAC[cfun_sums] THEN REPEAT STRIP_TAC THEN
           Pa.SUBGOAL_THEN
           `!n. cfun_sum (s INTER(0..n)) (\x. h1(f x)) = h1(cfun_sum (s INTER(0..n)) f):`
                 ASSUME_TAC
                 THENL[IMP_REWRITE_TAC[FINITE_INTER; FINITE_NUMSEG;
           GSYM(REWRITE_RULE[o_DEF] SLINEAR_CFUN_SUM_IMP)] THEN
                   ASM_MESON_TAC[ULINCOP_SUBSPACE;ULINCOP_ADD;ULINCOP_SMUL;is_set_linear_cop];
                                   ASM_SIMP_TAC[cfun_sums]
                                   THEN MATCH_MP_TAC CFUN_LIM_ULINEAR
                                   THEN Pa.EXISTS_TAC "s1" THEN
                                   ASM_MESON_TAC[CFUN_SUM_IN_SPC;ULINCOP_SUBSPACE;FINITE_INTER; FINITE_NUMSEG]
                                   ]);;

let CFUN_INFSUM_UNIQUE_ALT = prove
 (`!f l s s1 inprod. cfun_sums (s1,inprod) f l s ==> (l equv cfun_infsum (s1,inprod) s f) inprod`,
  MESON_TAC[CFUN_SERIES_UNIQUE; CFUN_SUMS_INFSUM; cfun_summable]);;

  
let CFUN_INFSUM_SLINEAR = prove
 (`!f h1 l s s1 s2 inprod. cfun_summable (s2,inprod) s f /\
   is_unbounded_linear_cop s1 h1  /\ 
   is_local_bounded1 (s2,inprod) h1 {x| ?n. x = cfun_sum (s INTER(0..n)) f - cfun_infsum (s2,inprod) s f}  /\
   (!x. x IN s1 ==> x IN s2 /\ h1 x IN s2) /\ 
     (!n. f n IN s1) /\  (cfun_infsum (s2,inprod) s f) IN s1
           ==> (cfun_infsum (s2,inprod) s (\n. h1(f n)) equv
                       h1 (cfun_infsum (s2,inprod) s f)) inprod`,
        REPEAT STRIP_TAC THEN MATCH_MP_TAC CFUN_INFSUM_UNIQUE THEN
		MATCH_MP_TAC CFUN_SERIES_SLINEAR THEN
		Pa.EXISTS_TAC "s1" THEN ASM_SIMP_TAC[CFUN_SUMS_INFSUM]);;

let CFUN_INFSUM_SLINEAR_ALT = prove
 (`!f h1 l s s1 s2 inprod. cfun_summable (s2,inprod) s f /\
   is_unbounded_linear_cop s1 h1  /\
   is_local_bounded1 (s2,inprod) h1 {x| ?n. x = cfun_sum (s INTER(0..n)) f - cfun_infsum (s2,inprod) s f}  /\
   (!x. x IN s1 ==> x IN s2 /\ h1 x IN s2) /\ 
     (!n. f n IN s1) /\  (cfun_infsum (s2,inprod) s f) IN s1
           ==> (h1 (cfun_infsum (s2,inprod) s f) 
		   equv cfun_infsum (s2,inprod) s (\n. h1(f n))) inprod`,
        REPEAT STRIP_TAC THEN MATCH_MP_TAC CFUN_INFSUM_UNIQUE_ALT THEN
		MATCH_MP_TAC CFUN_SERIES_SLINEAR THEN
		Pa.EXISTS_TAC "s1" THEN ASM_SIMP_TAC[CFUN_SUMS_INFSUM]);;
		
let CFUN_VSUM_SCALAR = prove
 (`!f q s.  FINITE s ==> cfun_sum s (\n.(f n) % x) = (vsum s f) % x`,
   GEN_TAC THEN GEN_TAC THEN MATCH_MP_TAC FINITE_INDUCT_STRONG THEN
   SIMP_TAC[CFUN_SUM_CLAUSES;VSUM_CLAUSES;COMPLEX_VEC_0;
   CFUN_SMUL_LZERO;CFUN_ADD_RDISTRIB]);;
   
let COP_EXP_SCALAR = prove
 (`!x a. x IN sq_integrable  ==>
       cfun_sums (sq_integrable,r_inprod) (\n. (Cx (inv(&(FACT n))) * (a pow n )) % x) ((cexp a)%x) (from 0)`,
	 MP_TAC CEXP_CONVERGES THEN
	 SIMP_TAC[cfun_sums;CFUN_LIM;LIM;sums;
	 CFUN_VSUM_SCALAR;FINITE_INTER;FINITE_NUMSEG;COP_POW_SCALAR;COP_SMUL;
	 CFUN_SMUL_ASSOC;TRIVIAL_LIMIT_SEQUENTIALLY;CX_INV;COMPLEX_FIELD `inv a * b  = b / a`;
	 cfun_dist] THEN
	 REWRITE_TAC[GSYM CFUN_SUB_RDISTRIB;GSYM CFUN_SMUL] THEN 
	 MP_SIMP_TAC[tem INNER_SPACE_SMUL;tem INPROD_RSMUL;tem INPROD_LSMUL] THEN 
         REWRITE_TAC[COMPLEX_MUL_CNJ;COMPLEX_MUL_ASSOC;COMPLEX_POW_2;
	 GSYM CX_MUL;GSYM REAL_POW_2;SQRT_MUL] THEN 
 	 IMP_REWRITE_TAC[REAL_OF_COMPLEX_MUL;REAL_CX;INPROD_SELF_REAL;REAL_OF_COMPLEX_CX;
	 NORM_POS_LE;POW_2_SQRT;SQRT_MUL;GSYM dist;GSYM cfun_norm;INPROD_SELF_POS;
	 REAL_LE_POW_2;DIST_POS_LE] THEN  REPEAT STRIP_TAC THEN ASM_SIMP_TAC[SQ_INTEGRABLE_INNER_SPACE]
	 THEN Pa.ASM_CASES_TAC "(x equv cfun_zero) r_inprod"
        THENL[ASM_MESON_TAC[tem CFUN_NORM_EQ_0;REAL_MUL_RZERO];
	  IMP_REWRITE_TAC[GSYM REAL_LT_RDIV_EQ;tem (GSYM CFUN_NORM_NZ);REAL_LT_DIV;SQ_INTEGRABLE_INNER_SPACE]
	  THEN   IMP_REWRITE_TAC[GSYM REAL_LT_RDIV_EQ;tem (GSYM CFUN_NORM_NZ);REAL_LT_DIV;SQ_INTEGRABLE_INNER_SPACE]]);;
	  
let COP_EXP_CEXP = prove
 (`!x a.   x IN sq_integrable
    ==> ((cfun_infsum (sq_integrable,r_inprod) (from 0) (\n. (Cx (inv(&(FACT n))) * (a pow n )) % x) )
	equv (cexp a % x))r_inprod`,
IMP_REWRITE_TAC[CFUN_INFSUM_UNIQUE;COP_EXP_SCALAR]);;

	
let CFUN_SUM_IN_SPC_ALT = prove
 (`!g spc s. FINITE s ==> is_cfun_subspace spc /\ (!n. n IN s ==> g n IN spc)  
    ==> cfun_sum s g IN spc`,
    GEN_TAC THEN GEN_TAC THEN 
    MATCH_MP_TAC FINITE_INDUCT_STRONG THEN SIMP_TAC[CFUN_SUM_CLAUSES]
    THEN IMP_REWRITE_TAC[CFUN_SUBSPACE_ZERO;CFUN_SUBSPACE_ADD;COMPONENT;IN_INSERT ]);;

let CFUN_SUM_LINPROD = prove
(`!f y s. FINITE s ==> (!n. n IN s ==> f n  IN sq_integrable) /\ y IN sq_integrable ==>
	 r_inprod (cfun_sum s f) y = vsum s (\n. r_inprod (f n) y)`,
	GEN_TAC THEN GEN_TAC THEN MATCH_MP_TAC FINITE_INDUCT_STRONG
		THEN ASM_SIMP_TAC[CFUN_SUM_CLAUSES;VSUM_CLAUSES; tem INPROD_LZERO;COMPLEX_VEC_0 ]
	THEN REPEAT STRIP_TAC THEN 
	 Pa.SUBGOAL_THEN "r_inprod (f x + cfun_sum s f) y = r_inprod (f x) y + r_inprod (cfun_sum s f) y" ASSUME_TAC
	 THENL[IMP_REWRITE_TAC[tem INPROD_ADD_RDIST;COMPONENT]
	 THEN ASM_MESON_TAC[IN_INSERT;CFUN_SUM_IN_SPC_ALT;SQ_INTEGRABLE_INNER_SPACE;INNER_SPACE_IS_SUBSPACE];ALL_TAC]
	 THEN IMP_REWRITE_TAC[IN_INSERT]);;

let CFUN_SUM_RINPROD = prove
(`!f y s. FINITE s ==> (!n. n IN s ==> f n  IN sq_integrable) /\ y IN sq_integrable ==>
	 r_inprod y (cfun_sum s f)  = vsum s (\n. r_inprod y (f n) )`,
	GEN_TAC THEN GEN_TAC THEN MATCH_MP_TAC FINITE_INDUCT_STRONG
		THEN ASM_SIMP_TAC[CFUN_SUM_CLAUSES;VSUM_CLAUSES; tem INPROD_RZERO;COMPLEX_VEC_0 ]
	THEN REPEAT STRIP_TAC THEN 
	 Pa.SUBGOAL_THEN "r_inprod y (f x + cfun_sum s f)  = r_inprod y (f x)  + r_inprod y (cfun_sum s f) " ASSUME_TAC
	 THENL[IMP_REWRITE_TAC[tem INPROD_ADD_LDIST;COMPONENT]
	 THEN ASM_MESON_TAC[IN_INSERT;CFUN_SUM_IN_SPC_ALT;SQ_INTEGRABLE_INNER_SPACE;INNER_SPACE_IS_SUBSPACE];ALL_TAC]
	 THEN IMP_REWRITE_TAC[IN_INSERT]);;

let INPROD_EQUV_RREPLACE_ALT = 	prove
	(`!s inprod x y z.
         is_inner_space (s,inprod)==>
		 (x equv y) inprod ==>
         x IN s /\
         y IN s /\
         z IN s
         ==> inprod z x = inprod z y`,
	   MESON_TAC[INPROD_EQUV_RREPLACE]);;	 

let EQUV_UNDER_INFSUM = prove
(`!f g. (!n. ((f n) equv (g n))r_inprod) /\ 
	cfun_summable (sq_integrable,r_inprod) (from 0) (\n. (f n))/\
	cfun_summable (sq_integrable,r_inprod) (from 0) (\n.  (g n))	==> 
	 (cfun_infsum (sq_integrable,r_inprod) (from 0) (\n.  (f n)) 
      equv cfun_infsum (sq_integrable,r_inprod) (from 0) (\n.  (g n)))r_inprod`,	  
	  IMP_REWRITE_TAC[CFUN_INFSUM_UNIQUE] THEN REWRITE_TAC[GSYM IMP_IMP] THEN 
	   REPEAT GEN_TAC THEN DISCH_TAC THEN DISCH_THEN (fun th -> DISCH_THEN (fun th1 -> ASSUME_TAC th THEN ASSUME_TAC th1 THEN MP_TAC th1 THEN MP_TAC th))
	   THEN REWRITE_TAC[cfun_summable;cfun_dist;cfun_sums;CFUN_LIM]
	  THEN IMP_REWRITE_TAC[INFSUM_IN_SPC] THEN REPEAT STRIP_TAC THEN ASM_SIMP_TAC[]   
	  THEN IMP_REWRITE_TAC[tem INPROD_SUB_LDIST;tem INPROD_SUB_RDIST;INFSUM_IN_SPC;INNER_SPACE_SUB] THEN 
	  IMP_REWRITE_TAC[CFUN_SUM_RINPROD;CFUN_SUM_LINPROD] THEN
	  Pa.SUBGOAL_THEN "!n. f n IN sq_integrable" ASSUME_TAC THENL[
	   INDUCT_TAC
	 THENL[FIRST_X_ASSUM(MP_TAC o (SPEC `0`)) THEN FIRST_X_ASSUM(MP_TAC o (SPEC `0`)) 
	 THEN SIMP_TAC[FROM_INTER_NUMSEG;CFUN_SUM_SING;NUMSEG_SING];
	 FIRST_X_ASSUM(MP_TAC o (SPEC `n:num`))
	 THEN FIRST_ASSUM(MP_TAC o (SPEC `n:num`))
     THEN FIRST_ASSUM(MP_TAC o (SPEC `SUC n`)) THEN 
	 REWRITE_TAC[FROM_INTER_NUMSEG;CFUN_SUM_CLAUSES_NUMSEG;ARITH_RULE `0 <= SUC n`]
	 THEN ASM_MESON_TAC[tem INNER_SPACE_SUB;CFUN_ARITH `!x y:cfun. y = (x +y)-x`]];ALL_TAC]
	 THEN ASM_SIMP_TAC[CFUN_SUM_RINPROD;FINITE_NUMSEG;FINITE_INTER] 
	  THEN IMP_REWRITE_TAC[INFSUM_IN_SPC;INNER_SPACE_SUB;FINITE_INTER;FINITE_NUMSEG] 
	  THEN  Pa.SUBGOAL_THEN "!n. g n IN sq_integrable" ASSUME_TAC THENL[
	   INDUCT_TAC
	 THENL[FIRST_X_ASSUM(MP_TAC o (SPEC `0`)) THEN FIRST_X_ASSUM(MP_TAC o (SPEC `0`)) 
	 THEN SIMP_TAC[FROM_INTER_NUMSEG;CFUN_SUM_SING;NUMSEG_SING];
	 FIRST_X_ASSUM(MP_TAC o (SPEC `n:num`))
	 THEN FIRST_ASSUM(MP_TAC o (SPEC `n:num`))
     THEN FIRST_ASSUM(MP_TAC o (SPEC `SUC n`)) THEN 
	 REWRITE_TAC[FROM_INTER_NUMSEG;CFUN_SUM_CLAUSES_NUMSEG;ARITH_RULE `0 <= SUC n`]
	 THEN ASM_MESON_TAC[tem INNER_SPACE_SUB;CFUN_ARITH `!x y:cfun. y = (x +y)-x`]];ALL_TAC]
	 THEN
	  FIRST_ASSUM(fun th -> MP_TAC (GEN_ALL ((MATCH_MP  (tem INPROD_EQUV_LREPLACE_ALT) (SPEC `n:num` th ))))) THEN
		  ASM_SIMP_TAC[]
		 THEN DISCH_TAC THEN IMP_REWRITE_TAC[] THEN
		 FIRST_ASSUM(fun th -> MP_TAC (GEN_ALL ((MATCH_MP  (tem INPROD_EQUV_RREPLACE_ALT) (SPEC `n:num` th ))))) 
	     THEN ASM_SIMP_TAC[]
		 THEN DISCH_TAC THEN IMP_REWRITE_TAC[]
		 THEN IMP_REWRITE_TAC[GSYM CFUN_SUM_RINPROD;GSYM CFUN_SUM_LINPROD]
		THEN ASM_SIMP_TAC[GSYM CFUN_SUM_RINPROD;GSYM CFUN_SUM_LINPROD;FINITE_NUMSEG;FINITE_INTER]
	   THEN IMP_REWRITE_TAC[GSYM CFUN_SUM_RINPROD;GSYM CFUN_SUM_LINPROD]
	 THEN IMP_REWRITE_TAC[GSYM (tem INPROD_SUB_LDIST);GSYM (tem INPROD_SUB_RDIST);INFSUM_IN_SPC;INNER_SPACE_SUB]
	  THEN RULE_ASSUM_TAC(REWRITE_RULE[ETA_AX])
	 THEN ASM_SIMP_TAC[FINITE_INTER;FINITE_NUMSEG] THEN
	  RULE_ASSUM_TAC(REWRITE_RULE[GSYM CFUN_SUMS_INFSUM;cfun_sums;CFUN_LIM])
	  THEN ASM_SIMP_TAC[ETA_AX;GSYM cfun_dist]);;
	  
let EQUV_UNDER_INFSUM_SMUL = prove
(`!f g a. (!n. ((a n) %(f n) equv (a n) %(g n))r_inprod) /\ 
	cfun_summable (sq_integrable,r_inprod) (from 0) (\n. (a n)%(f n))/\
	cfun_summable (sq_integrable,r_inprod) (from 0) (\n. (a n)% (g n))	==> 
	 (cfun_infsum (sq_integrable,r_inprod) (from 0) (\n.  (a n)%(f n)) 
      equv cfun_infsum (sq_integrable,r_inprod) (from 0) (\n.  (a n) %(g n)))r_inprod`,
		REPEAT STRIP_TAC THEN ASM_MESON_TAC[REWRITE_RULE [BETA_THM] (
		Pa.SPECL ["\\n. (a n)% (f n) "; "\\n. (a n)% (g n)"] EQUV_UNDER_INFSUM)]);; 
		
		

  
let INPROD_EQUV_REFL = inner_space_prove
	(`!x. (x equv x) inprod:`, 
	MESON_TAC[are_equv;CFUN_SUB_REFL;INPROD_ZERO]);;
